/* $Id: mrtginfo.c,v 1.2 1999/03/09 20:16:19 agulbra Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>

#include "ftpd.h"


char * uptime( void )
{
    char buf[1025];
    int f;
    int r;
    unsigned long u;

    f = open( "/proc/uptime", O_RDONLY );
    if ( f < 0 )
	return "?";

    r = read( f, buf, 1024 );
    if ( r <= 0 )
	return "?";
    close( f );

    u = strtoul( buf, NULL, 10 );
    sprintf( buf, "%lu days, %lu:%02lu:%02lu",
	     u/86400, u/3600%24, u/60%60, u%60 );
    return strdup( buf );
}


char * name( void )
{
    char buf[1025];
    int f;
    int r;

    f = open( "/proc/sys/kernel/hostname", O_RDONLY );
    if ( f < 0 )
	return "?";

    r = read( f, buf, 1024 );
    if ( r <= 0 )
	return "?";
    close( f );

    buf[r] = '\0';
    while( r && isspace( buf[r-1] ) )
	buf[--r] = '\0';
    return strdup( buf );
}


int main( /* int argc, char ** argv */ )
{
    int d = daemons();
    printf( "%d\n%d\n%s\n%s\n", d, d, uptime(), name() );
    return 0;
}
